package dev.fyloz.colorrecipesexplorer

import dev.fyloz.colorrecipesexplorer.config.ApplicationInitializer
import org.springframework.boot.autoconfigure.SpringBootApplication
import org.springframework.boot.autoconfigure.liquibase.LiquibaseAutoConfiguration
import org.springframework.boot.builder.SpringApplicationBuilder
import org.springframework.context.ConfigurableApplicationContext
import org.springframework.scheduling.annotation.EnableScheduling

@SpringBootApplication(exclude = [LiquibaseAutoConfiguration::class])
@EnableScheduling
class ColorRecipesExplorerApplication

var emergencyMode = false

private lateinit var context: ConfigurableApplicationContext
private lateinit var classLoader: ClassLoader

fun main() {
    classLoader = Thread.currentThread().contextClassLoader
    context = runApplication()
}

fun restartApplication(enableEmergencyMode: Boolean = false) {
    val thread = Thread {
        emergencyMode = enableEmergencyMode
        context.close()
        context = runApplication()
    }

    thread.contextClassLoader = classLoader
    thread.isDaemon = false
    thread.start()
}

private fun runApplication() =
    SpringApplicationBuilder(ColorRecipesExplorerApplication::class.java).apply {
        listeners(ApplicationInitializer())
    }.run()
